/**
 * String demos
 * 
 * @author Claude Sammut
 * @version 1/8/2012
 */

import java.io.*;

public class StringDemo
{
    // instance variables - replace the example below with your own
    String greeting = "Hello, World!";

    /**
     * Print the length of a string
     */
    public void strLength(String str)
    {
        int len = str.length();
        System.out.println("The length of \"" + str + "\" is " + len);
    }

    /**
     * Print a prompt and read a line from the terminal
     *
     * @param  prompt   the prompt string
     * @return          the string read in
     */
    public String readString(String prompt) throws IOException
    {
        // Create a reader object that reads from standard input
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        // Print the prompt message
        System.out.println(prompt);
        // Read one line and create a string to assign
        String line = reader.readLine();
        // Return the string value
        return line;
    }

    /**
     * Read a line from standard input
     * 
     * @return          the string read in
     */
    public String readLine()
    {
        // Create a reader object that reads from standard input
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        String line = "";
        // Read one line and create a string to assign
        try
        {
            line = reader.readLine();
        }
        catch (IOException e)
        {
            System.err.println("Something went wrong with readLine: " + e.getMessage());
        }
        // Return the string value
        return line;
    }

    /**
     * Read an integer from standard input
     * 
     * @return          the integer read in
     */
    public int readInt()
    {
        // Create a reader object that reads from standard input
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        String line = "";
        int n = 0;
        // Read one line and create a string to assign
        try
        {
            line = reader.readLine();
            n = Integer.parseInt(line);
        }
        catch (IOException e)
        {
            System.err.println("Something went wrong with readLine: " + e.getMessage());
        }
        catch (NumberFormatException e)
        {
            System.err.println("You didn't type in an integer");
        }
        // Return the string value
        return n;
    }

    /**
     * Read lines from the terminal until a single "." is entered
     */
    public void readLines1()
    {
        String line;
    
        System.out.println("Type a few lines");
        
        do
        {
            line = readLine();
            System.out.println("You typed: " + line);
        } while (! line.equals("."));
    }

    /**
     * Read lines from the terminal until a single "." is entered
     */
    public void readLines2()
    {
        String line;
        int sum = 0;
    
        System.out.println("Type a few lines");

        line = readLine();        
        while (! line.equals(""))
        {
            int i = Integer.parseInt(line);
            sum += i;
            System.out.println("the sum is: " + sum);
            line = readLine();
        }
    }

    /**
     * Read lines from the terminal until a single "." is entered
     * Assign each line to an element of an array until the size of the array is reached
     */
    public void readLines3()
    {
        final int maxLines = 5;
        String line;
        String[] lines = new String[maxLines];

        System.out.println("Type a few lines");
        
        int nLines = 0;
        do
        {
            line = readLine();
            if (nLines < maxLines)
            {
                lines[nLines++] = line;
            }
        } while (! line.equals("."));
        
        for (int i = 0; i < maxLines; i++)
        {
            System.out.println("Line " + i + " is: " + lines[i]);
        }
    }
}
